<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml">

    <h:outputScript library="javascripts" name="clipboard.min.js" target="head"/>
    <h:outputStylesheet library="stylesheets" name="clipboard.css" target="head"/>

    <s:div id="infoPanel">
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">
                <h:outputText value="#{messages['net.ihe.gazelle.proxy.MessageDetails']}"/>
                <em class="pull-right gzl-never-wrap">
                    <s:span title="This connection is shared with user who knows the privacy key"
                            styleClass="gzl-icon-share-alt text-info"
                            rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey != null}"/>
                    <s:span title="Only Admins can see messages from this connection"
                            styleClass="gzl-icon-lock"
                            rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey == null}"/>
                </em>
            </ui:define>
            <div class="row">

                <div class="col-md-4">
                    <dl class="dl-horizontal">

                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.PermanentLink']}</ui:define>
                            <span>
                                <h:outputLink value="#{messageBean.displayURLOfPage()}?id=#{messageBean.message.id}"
                                              rendered="#{(applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey == null) or !applicationConfigurationManager.isAdminOnlyMode()}">
                                    <h:outputText value="#{messageBean.displayURLOfPage()}?#{messages['net.ihe.gazelle.proxy.Id_2']}=#{messageBean.message.id}"/>
                                </h:outputLink>

                                <h:outputLink value="#{messageBean.displayURLOfPage()}?id=#{messageBean.message.id}&amp;privacyKey=#{messageBean.message.connection.privacyKey}"
                                              rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey != null}">
                                    <h:outputText value="#{messageBean.displayURLOfPage()}?#{messages['net.ihe.gazelle.proxy.Id_2']}=#{messageBean.message.id}#{messages['net.ihe.gazelle.proxy.privacyKey']}=#{messageBean.message.connection.privacyKey}"/>
                                </h:outputLink>

                                <s:div rendered="#{(applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey == null) or !applicationConfigurationManager.isAdminOnlyMode()}"
                                       style="display: inline-block;">
                                    <button type="button" id="copy-button-#{messageBean.message.id}" class="gzl-btn"
                                            data-clipboard-text="#{messageBean.displayURLOfPage()}?id=#{messageBean.message.id}"
                                            title="Copy to clipboard">
                                        <span class="fa fa-clipboard" style="margin-right:0;"/>
                                    </button>
                                    <script>
                                        var clip = new Clipboard('#copy-button-#{messageBean.message.id}');
                                        clip.on('success', function (e) {
                                            e.clearSelection();
                                            e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                                            e.trigger.setAttribute('aria-label', 'Copied!');
                                        });
                                        clip.on('error', function (e) {
                                            e.clearSelection();
                                            e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                                            e.trigger.setAttribute('aria-label', 'Failed! It may be not supported by your browser');
                                        });
                                        jq162('#copy-button-#{messageBean.message.id}').bind('mouseleave', function (e) {
                                            e.currentTarget.setAttribute('class', 'gzl-btn');
                                            e.currentTarget.removeAttribute('aria-label');
                                        });
                                    </script>
                                </s:div>
                                <s:div rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey != null}"
                                       style="display: inline-block;">
                                    <button type="button" id="copy-button-#{messageBean.message.id}-#{messageBean.message.connection.privacyKey}" class="gzl-btn"
                                            data-clipboard-text="#{messageBean.displayURLOfPage()}?id=#{messageBean.message.id}&amp;privacyKey=#{messageBean.message.connection.privacyKey}"
                                            title="Copy to clipboard">
                                        <span class="fa fa-clipboard" style="margin-right:0;"/>
                                    </button>
                                    <script>
                                        var clip = new Clipboard('#copy-button-#{messageBean.message.id}-#{messageBean.message.connection.privacyKey}');
                                        clip.on('success', function (e) {
                                            e.clearSelection();
                                            e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                                            e.trigger.setAttribute('aria-label', 'Copied!');
                                        });
                                        clip.on('error', function (e) {
                                            e.clearSelection();
                                            e.trigger.setAttribute('class', 'gzl-btn tooltipped tooltipped-s');
                                            e.trigger.setAttribute('aria-label', 'Failed! It may be not supported by your browser');
                                        });
                                        jq162('#copy-button-#{messageBean.message.id}-#{messageBean.message.connection.privacyKey}').bind('mouseleave', function (e) {
                                            e.currentTarget.setAttribute('class', 'gzl-btn');
                                            e.currentTarget.removeAttribute('aria-label');
                                        });
                                    </script>
                                </s:div>

                            </span>
                        </ui:decorate>

                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.ID']}</ui:define>
                            <h:outputText value="#{messageBean.message.id}"/>
                        </ui:decorate>

                        <h:panelGroup rendered="#{messageBean.message.connection.id!=null}">
                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.proxy.ConnectionID']}</ui:define>
                                <h:outputText value="#{messageBean.message.connection.id}"/>

                                <h:commandLink actionListener="#{messageBean.downloadFilesForConnection()}" execute="@this"
                                               title="#{messages['net.ihe.gazelle.proxy.DownloadAllMessagesFromThisConnection']}">
                                    <span class="gzl-icon-download"/>
                                </h:commandLink>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.proxy.ShareTheConnection']}"
                                        ignoreDupResponses="true"
                                        action="#{messageBean.shareMessage()}"
                                        render="infoPanel"
                                        rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey == null}">
                                    <span class="gzl-icon-share-alt text-info"/>
                                </a4j:commandLink>

                                <a4j:commandLink
                                        title="#{messages['net.ihe.gazelle.proxy.MakeTheConnectionPrivate']}"
                                        ignoreDupResponses="true"
                                        action="#{messageBean.makeResultPrivate()}"
                                        render="infoPanel"
                                        rendered="#{applicationConfigurationManager.isAdminOnlyMode() and messageBean.message.connection.privacyKey != null}">
                                    <span class="gzl-icon-lock"/>
                                </a4j:commandLink>
                            </ui:decorate>
                        </h:panelGroup>

                        <h:panelGroup
                                rendered="#{messageBean.getMessageIndex(messageBean.message)!='?' and messageBean.getMessageIndex(messageBean.message)!=null and messageBean.messageIndexMax&gt;1}">
                            <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Index']}</ui:define>
                                <div class="row">
                                    <div class="col-lg-5 col-xs-6">
                                        <rich:inputNumberSpinner value="#{messageBean.messageIndex}"
                                                                 minValue="1" maxValue="#{messageBean.messageIndexMax}">
                                            <a4j:ajax event="change"
                                                      listener="#{messageBean.redirectToMessage(messageBean.messageByIndex)}"
                                                      execute="@this"/>
                                        </rich:inputNumberSpinner>
                                    </div>
                                    <div class="col-xs-3">
                                        <p class="form-control-static">
                                            <h:outputText value="/#{messageBean.messageIndexMax}"/>
                                        </p>
                                    </div>
                                </div>
                            </ui:decorate>
                        </h:panelGroup>

                        <ui:decorate template="/layout/display/_data_list_item.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.DateReceived']}</ui:define>
                            <g:date value="#{messageBean.message.dateReceived}"/>
                        </ui:decorate>

                    </dl>
                </div>

                <div class="col-md-8">
                    <table class="rf-dt">
                        <thead class="rf-dt-thd">
                        <tr class="rf-dt-shdr">
                            <th class="rf-dt-shdr-c" colspan="2"  style="vertical-align: middle; text-align: center;">
                            </th>
                            <th class="rf-dt-shdr-c" colspan="2"  style="vertical-align: middle; text-align: center;">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Initiator']}"/>
                            </th>
                            <th class="rf-dt-shdr-c" colspan="2"  style="vertical-align: middle; text-align: center;">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Proxy']}"/>
                            </th>
                            <th class="rf-dt-shdr-c" colspan="2"  style="vertical-align: middle; text-align: center;">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Responder']}"/>
                            </th>
                        </tr>
                        </thead>
                        <tbody class="rf-dt-b" style="vertical-align: middle; text-align: center;">
                        <tr class="rf-dt-r rf-dt-fst-r">
                            <th class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.IP']}"/>
                            </th>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.fromIP}"/>
                            </td>
                            <td class="rf-dt-c" colspan="2" style="vertical-align: middle; text-align: center;">
                                <s:span styleClass="gzl-icon-arrow-right-request" title="Request"
                                        rendered="#{messageBean.message.proxySide.isRequest() and !messageBean.message.connection.isSecured()}"/>
                                <s:span styleClass="gzl-icon-arrow-left-response" title="Response"
                                        rendered="#{not messageBean.message.proxySide.isRequest() and !messageBean.message.connection.isSecured()}"/>
                            </td>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.toIP}"/>
                            </td>
                        </tr>
                        <tr class="rf-dt-r">
                            <th class="rf-dt-hdr-c" colspan="2">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.Port']}"/>
                            </th>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.localPort}"/>
                            </td>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.proxyPort}"/>
                            </td>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.remotePort}"/>
                            </td>
                        </tr>
                        <tr class="rf-dt-r">
                            <th class="rf-dt-hdr-c" colspan="2">
                                <h:outputText value="#{messages['net.ihe.gazelle.proxy.MessageLength']}"/>
                            </th>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.getMessageLength()}" rendered="#{messageBean.message.proxySide.isRequest()}"/>
                            </td>
                            <td class="rf-dt-c" colspan="2">
                            </td>
                            <td class="rf-dt-c" colspan="2">
                                <h:outputText value="#{messageBean.message.getMessageLength()}" rendered="#{not messageBean.message.proxySide.isRequest()}"/>
                            </td>
                        </tr>
                        <ui:fragment rendered="#{messageBean.message.connection.isSecured()}">
                            <tr class="rf-dt-r" style="height: 30px">
                                <td class="rf-dt-c" colspan="8">
                                </td>
                            </tr>
                            <tr class="rf-dt-r" >
                                <th class="rf-dt-hdr-c" colspan="2">
                                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.CertificateSubject']}"/>
                                </th>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.initiatorCertificateSubject}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.proxyCertificateSubject}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.responderCertificateSubject}"/>
                                </td>
                            </tr>
                            <tr class="rf-dt-r" >
                                <th class="rf-dt-hdr-c" colspan="2">
                                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.TLSProtocolUsed']}"/>
                                </th>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.protocolUsedBetweenInitAndProxy}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.protocolUsedBetweenRespAndProxy}"/>
                                </td>
                            </tr>
                            <tr class="rf-dt-r" >
                                <th class="rf-dt-hdr-c" colspan="2">
                                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.CiphersuiteUsed']}"/>
                                </th>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.cipherSuiteUsedBetweenInitAndProxy}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2" style="vertical-align: middle; text-align: center;">
                                    <s:span styleClass="gzl-icon-arrow-right-request" style="margin-top: -1.25em; font-size: 2em" title="Request"
                                            rendered="#{messageBean.message.proxySide.isRequest()}"/>
                                    <s:span styleClass="gzl-icon-arrow-left-response" style="margin-top: -1.25em; font-size: 2em" title="Response"
                                            rendered="#{not messageBean.message.proxySide.isRequest()}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.cipherSuiteUsedBetweenRespAndProxy}"/>
                                </td>
                            </tr>
                            <tr class="rf-dt-r" >
                                <th class="rf-dt-hdr-c" colspan="2">
                                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.HandshakeNotifications']}"/>
                                </th>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.handshakeNotificationBetweenInitAndProxy}"/>
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                </td>
                                <td class="rf-dt-c" colspan="2">
                                    <h:outputText value="#{messageBean.message.connection.handshakeNotificationBetweenRespAndProxy}"/>
                                </td>
                            </tr>
                        </ui:fragment>
                        </tbody>
                    </table>
                </div>

            </div>
        </ui:decorate>
    </s:div>
</ui:composition>
